// Generated by CoffeeScript 1.10.0
(function() {
  var CoffeeScript, DIRECTIVE, DepGraph, EXPLICIT_PATH, HEADER, HoldingQueue, Snockets, _, compilers, fs, jsExts, minify, parseDirectives, path, stripExt, timeEq, uglify,
    slice = [].slice,
    indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  DepGraph = require('dep-graph');

  CoffeeScript = require('coffee-script');

  fs = require('fs');

  path = require('path');

  uglify = require('uglify-js');

  _ = require('underscore');

  module.exports = Snockets = (function() {
    function Snockets(options) {
      var base, base1;
      this.options = options != null ? options : {};
      if ((base = this.options).src == null) {
        base.src = '.';
      }
      if ((base1 = this.options).async == null) {
        base1.async = true;
      }
      this.cache = {};
      this.concatCache = {};
      this.depGraph = new DepGraph;
    }

    Snockets.prototype.scan = function(filePath, flags, callback) {
      if (typeof flags === 'function') {
        callback = flags;
        flags = {};
      }
      if (flags == null) {
        flags = {};
      }
      if (flags.async == null) {
        flags.async = this.options.async;
      }
      return this.updateDirectives(filePath, flags, (function(_this) {
        return function(err, graphChanged) {
          if (err) {
            if (callback) {
              return callback(err);
            } else {
              throw err;
            }
          }
          if (typeof callback === "function") {
            callback(null, _this.depGraph, graphChanged);
          }
          return _this.depGraph;
        };
      })(this));
    };

    Snockets.prototype.getCompiledChain = function(filePath, flags, callback) {
      if (typeof flags === 'function') {
        callback = flags;
        flags = {};
      }
      if (flags == null) {
        flags = {};
      }
      if (flags.async == null) {
        flags.async = this.options.async;
      }
      return this.updateDirectives(filePath, flags, (function(_this) {
        return function(err, graphChanged) {
          var chain, compiledChain, e, error, link, o;
          if (err) {
            if (callback) {
              return callback(err);
            } else {
              throw err;
            }
          }
          try {
            chain = _this.depGraph.getChain(filePath);
          } catch (error) {
            e = error;
            if (callback) {
              return callback(e);
            } else {
              throw e;
            }
          }
          compiledChain = (function() {
            var i, len, ref, results;
            ref = chain.concat(filePath);
            results = [];
            for (i = 0, len = ref.length; i < len; i++) {
              link = ref[i];
              o = {};
              if (this.compileFile(link)) {
                o.filename = stripExt(link) + '.js';
              } else {
                o.filename = link;
              }
              o.js = this.cache[link].js.toString('utf8');
              results.push(o);
            }
            return results;
          }).call(_this);
          if (typeof callback === "function") {
            callback(null, compiledChain, graphChanged);
          }
          return compiledChain;
        };
      })(this));
    };

    Snockets.prototype.getConcatenation = function(filePath, flags, callback) {
      var concatenationChanged;
      if (typeof flags === 'function') {
        callback = flags;
        flags = {};
      }
      if (flags == null) {
        flags = {};
      }
      if (flags.async == null) {
        flags.async = this.options.async;
      }
      concatenationChanged = true;
      return this.updateDirectives(filePath, flags, (function(_this) {
        return function(err, graphChanged) {
          var chain, concatenation, e, error, link, ref, ref1, result;
          if (err) {
            if (callback) {
              return callback(err);
            } else {
              throw err;
            }
          }
          try {
            if ((ref = _this.concatCache[filePath]) != null ? ref.data : void 0) {
              concatenation = _this.concatCache[filePath].data.toString('utf8');
              if (!flags.minify) {
                concatenationChanged = false;
              }
            } else {
              chain = _this.depGraph.getChain(filePath);
              concatenation = ((function() {
                var i, len, ref1, results;
                ref1 = chain.concat(filePath);
                results = [];
                for (i = 0, len = ref1.length; i < len; i++) {
                  link = ref1[i];
                  this.compileFile(link);
                  results.push(this.cache[link].js.toString('utf8'));
                }
                return results;
              }).call(_this)).join('\n');
              _this.concatCache[filePath] = {
                data: new Buffer(concatenation)
              };
            }
          } catch (error) {
            e = error;
            if (callback) {
              return callback(e);
            } else {
              throw e;
            }
          }
          if (flags.minify) {
            if ((ref1 = _this.concatCache[filePath]) != null ? ref1.minifiedData : void 0) {
              result = _this.concatCache[filePath].minifiedData.toString('utf8');
              concatenationChanged = false;
            } else {
              result = minify(concatenation);
              _this.concatCache[filePath].minifiedData = new Buffer(result);
            }
          } else {
            result = concatenation;
          }
          if (typeof callback === "function") {
            callback(null, result, concatenationChanged);
          }
          return result;
        };
      })(this));
    };

    Snockets.prototype.updateDirectives = function() {
      var callback, depList, excludes, filePath, flags, graphChanged, i, q, require, requireTree;
      filePath = arguments[0], flags = arguments[1], excludes = 4 <= arguments.length ? slice.call(arguments, 2, i = arguments.length - 1) : (i = 2, []), callback = arguments[i++];
      if (indexOf.call(excludes, filePath) >= 0) {
        return callback();
      }
      excludes.push(filePath);
      depList = [];
      graphChanged = false;
      q = new HoldingQueue({
        task: (function(_this) {
          return function(depPath, next) {
            var err, ref;
            if (ref = path.extname(depPath), indexOf.call(jsExts(), ref) < 0) {
              return next();
            }
            if (depPath === filePath) {
              err = new Error("Script tries to require itself: " + filePath);
              return callback(err);
            }
            if (indexOf.call(depList, depPath) < 0) {
              depList.push(depPath);
            }
            return _this.updateDirectives.apply(_this, [depPath, flags].concat(slice.call(excludes), [function(err, depChanged) {
              if (err) {
                return callback(err);
              }
              graphChanged || (graphChanged = depChanged);
              return next();
            }]));
          };
        })(this),
        onComplete: (function(_this) {
          return function() {
            if (!_.isEqual(depList, _this.depGraph.map[filePath])) {
              _this.depGraph.map[filePath] = depList;
              graphChanged = true;
            }
            if (graphChanged) {
              _this.concatCache[filePath] = null;
            }
            return callback(null, graphChanged);
          };
        })(this)
      });
      require = (function(_this) {
        return function(relPath) {
          var depName, depPath, relName;
          q.waitFor(relName = stripExt(relPath));
          if (relName.match(EXPLICIT_PATH)) {
            depPath = relName + '.js';
            return q.perform(relName, depPath);
          } else {
            depName = _this.joinPath(path.dirname(filePath), relName);
            return _this.findMatchingFile(depName, flags, function(err, depPath) {
              if (err) {
                return callback(err);
              }
              return q.perform(relName, depPath);
            });
          }
        };
      })(this);
      requireTree = (function(_this) {
        return function(dirName) {
          q.waitFor(dirName);
          return _this.readdir(_this.absPath(dirName), flags, function(err, items) {
            var item, itemPath, j, len, results;
            if (err) {
              return callback(err);
            }
            q.unwaitFor(dirName);
            results = [];
            for (j = 0, len = items.length; j < len; j++) {
              item = items[j];
              itemPath = _this.joinPath(dirName, item);
              if (_this.absPath(itemPath) === _this.absPath(filePath)) {
                continue;
              }
              q.waitFor(itemPath);
              results.push((function(itemPath) {
                return _this.stat(_this.absPath(itemPath), flags, function(err, stats) {
                  if (err) {
                    return callback(err);
                  }
                  if (stats.isFile()) {
                    return q.perform(itemPath, itemPath);
                  } else {
                    requireTree(itemPath);
                    return q.unwaitFor(itemPath);
                  }
                });
              })(itemPath));
            }
            return results;
          });
        };
      })(this);
      return this.readFile(filePath, flags, (function(_this) {
        return function(err, fileChanged) {
          var command, directive, j, k, l, len, len1, len2, ref, relPath, relPaths, words;
          if (err) {
            return callback(err);
          }
          if (fileChanged) {
            graphChanged = true;
          }
          ref = parseDirectives(_this.cache[filePath].data.toString('utf8'));
          for (j = 0, len = ref.length; j < len; j++) {
            directive = ref[j];
            words = directive.replace(/['"]/g, '').split(/\s+/);
            command = words[0], relPaths = 2 <= words.length ? slice.call(words, 1) : [];
            switch (command) {
              case 'require':
                for (k = 0, len1 = relPaths.length; k < len1; k++) {
                  relPath = relPaths[k];
                  require(relPath);
                }
                break;
              case 'require_tree':
                for (l = 0, len2 = relPaths.length; l < len2; l++) {
                  relPath = relPaths[l];
                  requireTree(_this.joinPath(path.dirname(filePath), relPath));
                }
            }
          }
          return q.finalize();
        };
      })(this));
    };

    Snockets.prototype.findMatchingFile = function(filename, flags, callback) {
      var tryFiles;
      tryFiles = (function(_this) {
        return function(filePaths) {
          var filePath, i, len;
          for (i = 0, len = filePaths.length; i < len; i++) {
            filePath = filePaths[i];
            if (stripExt(_this.absPath(filePath)) === _this.absPath(filename)) {
              callback(null, filePath);
              return true;
            }
          }
        };
      })(this);
      if (tryFiles(_.keys(this.cache))) {
        return;
      }
      return this.readdir(path.dirname(this.absPath(filename)), flags, (function(_this) {
        return function(err, files) {
          var file;
          if (err) {
            return callback(err);
          }
          if (tryFiles((function() {
            var i, len, results;
            results = [];
            for (i = 0, len = files.length; i < len; i++) {
              file = files[i];
              results.push(this.joinPath(path.dirname(filename), file));
            }
            return results;
          }).call(_this))) {
            return;
          }
          return callback(new Error("File not found: '" + filename + "'"));
        };
      })(this));
    };

    Snockets.prototype.readdir = function(dir, flags, callback) {
      var e, error, files;
      if (flags.async) {
        return fs.readdir(this.absPath(dir), callback);
      } else {
        try {
          files = fs.readdirSync(this.absPath(dir));
          return callback(null, files);
        } catch (error) {
          e = error;
          return callback(e);
        }
      }
    };

    Snockets.prototype.stat = function(filePath, flags, callback) {
      var e, error, stats;
      if (flags.async) {
        return fs.stat(this.absPath(filePath), callback);
      } else {
        try {
          stats = fs.statSync(this.absPath(filePath));
          return callback(null, stats);
        } catch (error) {
          e = error;
          return callback(e);
        }
      }
    };

    Snockets.prototype.readFile = function(filePath, flags, callback) {
      return this.stat(filePath, flags, (function(_this) {
        return function(err, stats) {
          var data, e, error, ref;
          if (err) {
            return callback(err);
          }
          if (timeEq((ref = _this.cache[filePath]) != null ? ref.mtime : void 0, stats.mtime)) {
            return callback(null, false);
          }
          if (flags.async) {
            return fs.readFile(_this.absPath(filePath), function(err, data) {
              if (err) {
                return callback(err);
              }
              _this.cache[filePath] = {
                mtime: stats.mtime,
                data: data
              };
              return callback(null, true);
            });
          } else {
            try {
              data = fs.readFileSync(_this.absPath(filePath));
              _this.cache[filePath] = {
                mtime: stats.mtime,
                data: data
              };
              return callback(null, true);
            } catch (error) {
              e = error;
              return callback(e);
            }
          }
        };
      })(this));
    };

    Snockets.prototype.compileFile = function(filePath) {
      var ext, js, src;
      if ((ext = path.extname(filePath)) === '.js') {
        this.cache[filePath].js = this.cache[filePath].data;
        return false;
      } else {
        src = this.cache[filePath].data.toString('utf8');
        js = compilers[ext.slice(1)].compileSync(this.absPath(filePath), src);
        this.cache[filePath].js = new Buffer(js);
        return true;
      }
    };

    Snockets.prototype.absPath = function(relPath) {
      if (relPath.match(EXPLICIT_PATH)) {
        return relPath;
      } else if (this.options.src.match(EXPLICIT_PATH)) {
        return this.joinPath(this.options.src, relPath);
      } else {
        return this.joinPath(process.cwd(), this.options.src, relPath);
      }
    };

    Snockets.prototype.joinPath = function() {
      var filePath, slash;
      filePath = path.join.apply(path, arguments);
      if (process.platform === 'win32') {
        slash = '/';
        return filePath.replace(/\\/g, slash);
      } else {
        return filePath;
      }
    };

    return Snockets;

  })();

  module.exports.compilers = compilers = {
    coffee: {
      match: /\.js$/,
      compileSync: function(sourcePath, source) {
        return CoffeeScript.compile(source, {
          filename: sourcePath
        });
      }
    }
  };

  EXPLICIT_PATH = /^\/|:/;

  HEADER = /(?:(\#\#\#.*\#\#\#\n*)|(\/\/.*\n*)|(\#.*\n*))+/;

  DIRECTIVE = /^[\W]*=\s*(\w+.*?)(\*\\\/)?$/gm;

  HoldingQueue = (function() {
    function HoldingQueue(arg) {
      this.task = arg.task, this.onComplete = arg.onComplete;
      this.holdKeys = [];
    }

    HoldingQueue.prototype.waitFor = function(key) {
      return this.holdKeys.push(key);
    };

    HoldingQueue.prototype.unwaitFor = function(key) {
      return this.holdKeys = _.without(this.holdKeys, key);
    };

    HoldingQueue.prototype.perform = function() {
      var args, key;
      key = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
      return this.task.apply(this, slice.call(args).concat([(function(_this) {
        return function() {
          return _this.unwaitFor(key);
        };
      })(this)]));
    };

    HoldingQueue.prototype.finalize = function() {
      var h;
      if (this.holdKeys.length === 0) {
        return this.onComplete();
      } else {
        return h = setInterval(((function(_this) {
          return function() {
            if (_this.holdKeys.length === 0) {
              _this.onComplete();
              return clearInterval(h);
            }
          };
        })(this)), 10);
      }
    };

    return HoldingQueue;

  })();

  parseDirectives = function(code) {
    var header, match, results;
    code = code.replace(/[\r\t ]+$/gm, '\n');
    if (!(match = HEADER.exec(code))) {
      return [];
    }
    header = match[0];
    results = [];
    while (match = DIRECTIVE.exec(header)) {
      results.push(match[1]);
    }
    return results;
  };

  stripExt = function(filePath) {
    var ref;
    if (ref = path.extname(filePath), indexOf.call(jsExts(), ref) >= 0) {
      return filePath.slice(0, filePath.lastIndexOf('.'));
    } else {
      return filePath;
    }
  };

  jsExts = function() {
    var ext;
    return ((function() {
      var results;
      results = [];
      for (ext in compilers) {
        results.push("." + ext);
      }
      return results;
    })()).concat('.js');
  };

  minify = function(js) {
    var ast, jsp, pro;
    jsp = uglify.parser;
    pro = uglify.uglify;
    ast = jsp.parse(js);
    ast = pro.ast_mangle(ast);
    ast = pro.ast_squeeze(ast);
    return pro.gen_code(ast);
  };

  timeEq = function(date1, date2) {
    return (date1 != null) && (date2 != null) && date1.getTime() === date2.getTime();
  };

}).call(this);
